mybit={data32={}}

for i=1,32 do 
    mybit.data32[i]=2^(32-i) 
end 

function mybit:d2b(arg) --mybit:d2b 
	local tr={} 
	
	    for i=1,32 do 
		    if arg >= mybit.data32[i] then 
			    tr[i]=1 
			    arg=arg-mybit.data32[i] 
		    else 
			    tr[i]=0 
		    end 
	    end 
	return tr 
end 

function mybit:b2d(arg) --mybit:b2d 
	local nr=0 
	for i=1,32 do 
		if arg[i] ==1 then 
			nr=nr+2^(32-i) 
		end 
	end 
	return nr 
end 

function mybit:_xor(a,b) --mybit:xor 
    local op1=mybit:d2b(a)
    local op2=mybit:d2b(b)

    local r={} 

    for i=1,32 do 
	   if op1[i]==op2[i] then 
		  r[i]=0 
	   else 
		  r[i]=1 
	   end
    end 
    return mybit:b2d(r) 
end 

--===============================================================
function mybit:_xor16(a,b) --mybit:xor 
    local op1=mybit:d2b(a)
    local op2=mybit:d2b(b)

    local r={} 

    for i=1,32 do 
	   if op1[i]==op2[i] then 
		  r[i]=0 
	   else 
		  r[i]=1 
	   end
    end 
    return mybit:b2d(r) 
end 
--===============================================================

function mybit:_and(a,b) --mybit:_and 
	local op1=mybit:d2b(a) 
	local op2=mybit:d2b(b) 
	local r={} 
	
	for i=1,32 do 
		if op1[i]==1 and op2[i]==1 then 
			r[i]=1 
		else 
			r[i]=0 
		end 
	end 
	return mybit:b2d(r) 
	
end 

function mybit:_or(a,b) --mybit:_or 
	local op1=mybit:d2b(a) 
	local op2=mybit:d2b(b) 
	local r={} 
	
	for i=1,32 do 
		if op1[i]==1 or op2[i]==1 then 
			r[i]=1 
		else 
			r[i]=0 
		end 
	end 
	return mybit:b2d(r) 
end 

function mybit:_not(a) --mybit:_not 
	local op1=mybit:d2b(a) 
	local r={} 
	
	for i=1,32 do 
		if op1[i]==1 then 
			r[i]=0 
		else 
			r[i]=1 
		end 
	end 
	return mybit:b2d(r) 
end 

function mybit:_rshift(a,n) --mybit:_rshift 
	local op1=mybit:d2b(a) 
	local r=mybit:d2b(0) 
	
	if n < 32 and n > 0 then 
		for i=1,n do 
			for i=31,1,-1 do 
				op1[i+1]=op1[i] 
			end 
			op1[1]=0 
		end 
		r=op1 
	end 
	return mybit:b2d(r) 
end 

function mybit:_lshift(a,n) --mybit:_lshift 
	local op1=mybit:d2b(a) 
	local r=mybit:d2b(0) 
	
	if n < 32 and n > 0 then 
		for i=1,n do 
			for i=1,31 do 
				op1[i]=op1[i+1] 
			end 
			op1[32]=0 
		end 
		r=op1 
	end 
	return mybit:b2d(r) 
end


function mybit:print(ta) 
	local sr="" 
	for i=1,32 do 
		sr=sr..ta[i] 
	end 
	print(sr) 
end